# Event Timestamps (EventGenerator)

The [Event Timestamps](https://docs.tonic.ai/app/generation/generators/generator-reference/event-timestamps) generator generates timestamps that fit an event distribution. The source timestamp must include a date. It cannot be a time-only value.

## Link object structure <a href="#generator-api-event-timestamps-link-object" id="generator-api-event-timestamps-link-object"></a>

You can link columns to create a sequence of events across multiple columns. This generator can be partitioned by other columns.

The Event Timestamps generator does not support consistency. You cannot configure differential privacy.

The `metadata` object is populated from the [`EventMetadata`](https://app.tonic.ai/apidocs/index.html#/models/EventMetadata) object. You use `eventOrder` to specify the sequence of the generated datetime values in the linked columns.

The Event Timestamps generator does support partitioning, which is configured in the [`partitions` object outside of the `links` object](https://docs.tonic.ai/app/api/quick-start-guide/tonic-api-generator-assignment-structure#tonic-api-generator-partition-column-list).

```json
{
  "schema": "string",
  "table": "string",
  "column": "string",
  "metadata": {
    "generatorId": "EventGenerator",
    "eventOrder": integer,
    "encryptionProcessor": "x-on", //To use configured Structural data encryption
    "customValueProcessor": "string"  //If custom value processor applied
  }
}
```

## Example replacement <a href="#generator-api-event-timestamps-replacement" id="generator-api-event-timestamps-replacement"></a>

In this replacement example for the Event Timestamps generator, the `date_event1` and `date_event2` columns are linked. `date_event1` occurs first, and `date_event2` occurs second. The values are not partitioned.

```json
{
  "name": "date_event1,date_event2",
  "schema": "public",
  "table": "events",
  "links": [
    {
      "schema": "public",
      "table": "events",
      "column": "date_event1",
      "metadata": {
        "generatorId": "EventGenerator",
        "eventOrder": 1
      }
    },
    {
      "schema": "public",
      "table": "events",
      "column": "date_event2",
      "metadata": {
        "generatorId": "EventGenerator",
        "eventOrder": 2
      }
    }
  ],
  "partitions": []
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.tonic.ai/app/api/quick-start-guide/tonic-api-generator-assignment/generator-api-reference/generator-api-ref-event-timestamps.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
